/* 
    Ec      Copyright (C)   2001 Marc Dechico


    ec_menu.h : Teletyp interface to let the user play
    
     
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: ec@dechico.com 
    
*/

#include "ec_global.h"

/*************************************************/
/* external data                                 */
/*************************************************/
extern  char tc_sep_tir[];
extern char version[];
extern char package[];
extern char package_string[];
extern char package_bugreport[];
extern char package_www[];
extern struct st_aff tst_aff[st_aff_dim];

/* tableau historique des coups */
extern  struct st_hst_pro ts_hst_pro[PRO_HST];

extern struct st_pie ts_pie_0[18];/* pèce camp 0			*/

extern struct st_pie ts_pie_1[18];/* pièce camp 1			*/

extern struct st_pie *tpts_pie[2];/* tableau pointant sur pièce camp 0 ou 1 */
                                  /* poste 0 camp 0, 1 camp 1 */

extern struct st_ech ts_ech[100]; /* tableau echiquier accès par l'emplacement  */

extern struct st_eva_sit st_eva_sit;/* structure pour evaluation rapport de force */

extern int (*pf_eva) (void);  	  /* pointeur sur fonction evaluation */

extern int (*tpf_eva[100]) (void);/* tableau pointeur sur fonction evaluation */

extern defv_bool defv_aff_not_pos;    /* =1 si affichage note possible */

extern defv_bool defv_aff_cal_cou;	  /* = 1 si affichage calcul en cour */

extern int i_pro_act;             /* profondeur actuelle	*/

extern int i_pro_sim_niv;	  /* niveau de simulation */

extern int i_pro_sim_inc;	  /* nivde simu pour incremen*/

extern int i_pro_sim_max_inf;     /* profondeur maximale inferieur	*/

extern defv_bool defv_sto_sim_cla;	  /* si = 1 CTL C pendant simulation-> arret simu */

extern int i_not_cpt_mvt_ini;	  /* note: compteur mvt initial 		*/

extern struct st_hst_pro *pts_hst_pro;/* ptr sur tableau structure historique  */

extern struct st_pie *pts_pie;    /* ptr sur tbl structure pièce principale*/


/*************************************************/
/* local  data                                   */
/*************************************************/
static char tc_sep_ast[]=
  "\n*******************************************************************************";

struct option longopts[] =
{
  { "version", no_argument, NULL, 'v' },
  { "help", no_argument, NULL, 'h' },
  { NULL, 0, NULL, 0 }
};

char *progname;
static int i_cot_aff;                    /* cote d'affichage 0= BLANC 1= NOIR */
int i_ver_eva;				/* Numero d'evaluation  */


